signature GLOBALS = sig

(* The pervasive global environment.  By convention, all signatures and 
   functor bodies include the substructure Globals and open it outside 
   the scope of the rest of their contents. *)

structure WrMgt: WRMGT
structure Id: ID


(* ---------------------------------------------------------------------- *)
(* Low-level utilities *)

include WRMGT
include LISTUTILS
include STRINGUTILS
include DEBUGUTILS


(* ---------------------------------------------------------------------- *)
(* Global registries *)

(* flags *)
val createflag: string list -> bool -> (bool ref)
val set_flag: string -> bool -> unit

(* named commands *)
val register_cmd: string -> (string option -> unit) -> unit
val do_cmd: string -> string option -> unit

(* statistics *)
val statsproc: string list -> (unit -> unit) -> unit
val stats: string -> unit
val allstats: unit -> unit

(* reset procedures *)
val resetproc: (unit -> unit) -> unit
val global_reset: unit -> unit

(* finalization procedures *)
val finalizeproc: (unit -> unit) -> unit
val global_finalize: unit -> unit


(* ---------------------------------------------------------------------- *)
(* Miscellaneous *)

exception CantHappen
exception NotImplemented of string

end
