functor Interface () : INTERFACE =
struct

val firstline = 1  

type pos = string * (int ref)
val line = ref(("BOGUS PARSER CONTEXT", ref(firstline)))

exception PoppedTooManyParserContexts
val old_contexts = ref(nil: (string*(int ref)) list)

fun begin_parser_context name = 
  (old_contexts := (!line)::(!old_contexts);
   line := (name,ref(firstline)))

fun end_parser_context () =
  (if null (!old_contexts)
     then raise PoppedTooManyParserContexts
     else ();
   line := hd (!old_contexts);
   old_contexts := tl (!old_contexts))

fun next_line () = let
  val (name,l) = !line
  in l := !l+1
  end

fun error (errmsg,(name,l):pos,_) = 
  (output (std_err, 
      if name <> "" 
        then name ^ ":" ^ (makestring (!l)) ^ " Error: " ^ errmsg ^ "\n"
        else "Error on line " ^ (makestring (!l)) ^ ": " ^ errmsg ^ "\n"
        ))

end 

