functor Wr () : WR =
struct

datatype wr = 
	WR of wr_spc * unit

and wr_spc = 
        TO_STDOUT
      | TO_FILE of string * outstream
      | TO_WRS of wr list
      | TO_STRING of string list ref
      | TO_FN of (string->unit) * (unit->unit) * (unit->unit)
      | TO_NOWHERE 
	
type Wr = wr

fun new spc = WR(spc, ())

fun to_stdout () = new (TO_STDOUT)

fun to_file name = let
  val out = open_out name
  in new (TO_FILE(name,out))
  end

fun to_wrs wrs = new (TO_WRS(wrs))

fun to_fn f cl_f fl_f = new (TO_FN(f,cl_f,fl_f))

fun to_string () = new (TO_STRING(ref([]:string list)))

fun to_nowhere () = new (TO_NOWHERE)

exception Not_a_TOSTRING_Wr

fun extract_str (WR(TO_STRING(ss),_)) = implode (rev (!ss))
  | extract_str _ = raise Not_a_TOSTRING_Wr

fun mapunit f = 
    let fun m ([]) = ()
          | m (hd::tl) = ((f hd); m tl)
    in m
    end

fun close (WR(spc,gen)) = 
    case spc of
       TO_STDOUT => ()
     | TO_FILE(name,out) => close_out out
     | TO_WRS(wrs) => mapunit close wrs
     | TO_FN(_,cl_f,_) => cl_f()
     | TO_STRING(ss) => ()
     | TO_NOWHERE => ()

fun flush (WR(spc,gen)) = 
    case spc of
       TO_STDOUT => ()
     | TO_FILE(name,out) => ()
     | TO_WRS(wrs) => mapunit close wrs
     | TO_FN(_,_,fl_f) => fl_f()
     | TO_STRING(ss) => ()
     | TO_NOWHERE => ()

fun write_wr (WR(spc,gen)) s =
    case spc of
       TO_STDOUT => output(std_out,s)
     | TO_FILE(_,out) => output(out,s)
     | TO_WRS(wrs) => mapunit (fn wr => write_wr wr s) wrs
     | TO_FN(f,_,_) => f s
     | TO_STRING(ss) => ss := (s :: (!ss))
     | TO_NOWHERE => ()

end 
