"Smalltalk implementation of the Point and CPoint classes."
"---------------------------------------------------------"

"Declare the class Point to be a subclass of Object with a single"
"instance variable x."
Class Point Object   x

"Define the operations available on Point objects.  (The new method is called"
"once to initialize a just-created instance of Point.  The methods setX: and"
"getX are the interface seen by other objects.)"
Methods Point 
  new 
        "Initialize a new point"
        x <- 0.  
        ^ self   
|
  setX: newx
        x <- newx.   "set the instance variable x to the value of"
                     "the parameter newx"        
        ^ self       "return self"
|
  getX
        ^ x          "Return the value of the instance variable x"
]


"Declare the class CPoint to be a subclass of Point with a new instance"
"variable named color.  New methods named getC and setC: are provided for"
"accessing and updating this field.  The new and setX methods are overriden."
"(For the sake of the example, sending setX: to an instance of CPoint"
"should change its color to blue.)"    
Class CPoint Point   color

Methods CPoint
  new 
        color <- 'red'.   "Set the color to red initially"
        super new.        "Invoke the new method of Point"
        ^ self            "return self"
|
  setX: newx
        color <- 'blue'.     "set the instance variable color to blue."
        super setX: newx.    "use the setX: method of Point to actually"
                             "update the x coordinate."
        ^ self               "return self"
|
  setC: newc
        color <- newc.    "set the instance variable color to the value of"
                          "the parameter newc"        
        ^ self            "return self"
|
  getC
        ^ color           "Return the value of the instance variable color"
]
