(* $$$ probably move this into Simplify so that squash can call it directly *)

functor Abbrev(
	  structure Typ: TYP
	  structure TEnv: TENV
	  structure TypHelper: TYPHELPER
	  structure Globals: GLOBALS
 	  structure Leq: LEQ
	  sharing Typ.Globals = Globals
	      and TypHelper.Typ = Typ
	      and TypHelper.TEnv = TEnv
	      and Typ.Id = Globals.Id
	      and Leq.TEnv = TEnv
	      and Leq.Typ = Typ
	  ) : ABBREV = struct

structure Typ = Typ
structure Globals = Globals
structure TEnv = TEnv
open Globals
open TypHelper
open TEnv
open Typ

val DEBUG = createflag ["abbrev", "Abbrev"] false

fun collapse te t = t

fun collapse_one' te iab tab t =
  if (Leq.eqv te tab t) 
     (* The old version might be better for some purposes:  
        if (Typ.eq tab t)
      *)
    then tvar(iab)
    else case explode(t) of
               EXPTVAR i => t
             | EXPARROW (t1,t2) => arrow (collapse_one te iab tab t1)
         			(collapse_one te iab tab t2)
	     | EXPALL (n,t1,t2) => all n (collapse_one te iab tab t1)
	 			  (collapse_one (push_bound te n t1) 
	 					(iab+1) (relocate 1 tab) t2)
	     | EXPSOME (n,t1,t2) => some n (collapse_one te iab tab t1)
	 			   (collapse_one (push_bound te n t1) 
	 				 	 (iab+1) (relocate 1 tab) t2)
	     | EXPMEET ts => meet (map (fn t => collapse_one te iab tab t) ts)
	     | EXPOBJ (n,t) => obj n (collapse_one te iab tab t)
	     | EXPMINUS (t,ids) => minus (collapse_one te iab tab t) ids

and collapse_one te iab tab t =
  wrap (DEBUG) "collapse_one"
       (fn () => collapse_one' te iab tab t)
       (fn () => 
       	  (setb ();
       	   write (makestring iab);
       	   write " == ";
       	   prt te tab;
       	   break true ~3;
       	   write "   in ";
       	   prt te t;
       	   endb ()))
       (fn t => 
          (prt te t))
  
fun collapse' te t = let
  val len = domsize te
  fun c ~1 t = t
    | c n t = lookup_and_relocate te n
                (fn _ => c (n-1) t)
                (fn _ => c (n-1) t)
                (fn ab => c (n-1) (collapse_one te n ab t))
  in c (len-1) t
  end

fun collapse te t =
  wrap (DEBUG) "collapse"
       (fn () => collapse' te t)
       (fn () => 
       	  (prt te t;
       	   write "\n";
       	   write "in ";
       	   TypHelper.prt_tenv te))
       (fn t => 
          (TypHelper.prt te t))
  
end
