signature TRMHELPER = sig

structure Globals: GLOBALS
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
structure Trm: TRM
sharing Typ.Globals = Globals
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
    and Trm.TEnv = TEnv

include GLOBALS

datatype pretrm = 
	    PREVAR of Id.T
	  | PREABS of Id.T * TypHelper.pretyp * pretrm
	  | PREAPP of pretrm * pretrm
	  | PRETABS of Id.T * TypHelper.pretyp * pretrm
	  | PRETAPP of pretrm * TypHelper.pretyp
	  | PREFOR of Id.T * (TypHelper.pretyp list) * pretrm
	  | PREQUERY of string * pretrm
	  | PREPROJ of pretrm * Id.T 
	  | PREWITH of pretrm * Id.T * pretrm
	  | PREOPEN of Id.T * Id.T * pretrm * pretrm
	  | PREPACK of pretrm * TypHelper.pretyp * TypHelper.pretyp
	  | PRENOTHING

exception UnknownId of string
val debruijnify: TEnv.T -> pretrm -> Trm.T
val prt: TEnv.T -> Trm.T -> unit

end
