signature TYP = sig

structure Globals: GLOBALS
include GLOBALS

datatype K = 
	    STAR
	  | KARROW of K * K

datatype T = 
	    TVAR of int
	  | ABST of Id.T * K * T
	  | APPT of T * T
	  | ARROW of T * T
	  | ALL of Id.T * T * T
	  | SOM of Id.T * T * T
	  | TOP of K
	  | RCD of (Id.T * T) list

val star: K
val karrow: K -> K -> K

val tvar: int -> T
val abst: Id.T -> K -> T -> T
val appt: T -> T -> T
val arrow: T -> T -> T
val all: Id.T -> T -> T -> T
val some: Id.T -> T -> T -> T
val top: K -> T
val rcd: (Id.T * T) list -> T

val relocate_above: int -> int -> T -> T
val relocate: int -> T -> T

val tsubst_top: 
	(* substitute... *)			T 
	(* for instances of #0 in... *)	     -> T 
			     		     -> T
val tsubst: 
	(* substitute... *)			T 
	(* for instances of variable #... *) -> int
	(* in... *)             	     -> T 
			     		     -> T
val occurs_free_in:
	(* is var #... *)		int
	(* free in type... ? *)      -> T
				     -> bool
val kprt_exactly: K -> unit
val prt_exactly: T -> unit

val dummytype: T

end

