signature PARSERES = sig

structure TypHelper: TYPHELPER
structure TrmHelper : TRMHELPER
structure Globals: GLOBALS
sharing TrmHelper.TypHelper = TypHelper
    and TypHelper.Id = Globals.Id
    and TrmHelper.Id = Globals.Id
    and TrmHelper.Globals = Globals
    and TrmHelper.Trm.TypHelper = TypHelper

datatype SystemSpecific = 
    Leq of TypHelper.PreTyp * TypHelper.PreTyp
  | Eqv of TypHelper.PreTyp * TypHelper.PreTyp
  | Type_Assumption of Globals.Id.T * TypHelper.PreTyp
  | Type_Abbrev of Globals.Id.T * TypHelper.PreTyp
  | Term_Def of Globals.Id.T * TrmHelper.PreTrm
  | Term_Assumption of Globals.Id.T * TypHelper.PreTyp
  | PrinterDecl of TrmHelper.PreTrm
  | ObjectTypeDecl of 
       Globals.Id.T 
     * Globals.Id.T 
     * ((Globals.Id.T * TypHelper.PreTyp) list)
  | ClassDecl of 
       Globals.Id.T 
     * Globals.Id.T 
     * Globals.Id.T 
     * Globals.Id.T 
     * (Globals.Id.T * TypHelper.PreTyp * TrmHelper.PreTrm) list
     * Globals.Id.T list
     * Globals.Id.T list
     * (Globals.Id.T * TrmHelper.PreTrm) list

datatype Item =
    Specific of SystemSpecific
  | Use of string
  | Set of string * string
  | Cmd of string * (string option)
  | Nothing

datatype T = ITEMS of Item list

val oldSyntax : string->unit  (* to generate warnings when old syntax is used *)

end 
